include "Vram.inc"
include "VVram.inc"
; include "Chars.inc"

ext WRTVRM, FILVRM
ext VVram_
ext FortPattern

VramTop equ Vram
FortSize equ 6

; void InitVdp();
cseg
VdpValues:
    defb 06h,0e2h
    defb 0ffh,0ffh,0ffh,0ffh,0fbh,00h
    defb 48,224-24
    defb 0
ColorValues:
    defb 0,0
    defb 0,15
    defb 15,0
    defb 15,15
    defb 240,0
    defb 240,15
    defb 255,0
    defb 255,15
    defb 51,3
    defb 0,12
    defb 12,0
    defb 12,12
    defb 252,15
    defb 192,12
    defb 204,0
    defb 204,12
InitVdp_: public InitVdp_
    push af | push hl | push de | push bc
        ld hl,VdpValues
        ld c,0
        ld b,11
        do
            ld a,(hl) | out (VdpPort+1),a
            inc hl
            ld a,c | or 80h | out (VdpPort+1),a
            inc c
        dwnz

        xor a | out (VdpPort+1),a
        ld a,0c0h | out (VdpPort+1),a
        ld c,2
        do
            ld hl,ColorValues
            ld b,16*2
            do
                ld a,(hl) | inc hl
                out (VdpPort),a
            dwnz
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret

; void InitMonoChar(word vram, ptr<byte> p, byte count, byte color);
dseg
InitMonoChar_@Param3: public InitMonoChar_@Param3
    defb 0
cseg
InitMonoChar_: public InitMonoChar_
    push af | push hl | push de | push bc
        ld a,l | out (VdpPort+1),a
        ld a,h | or 40h | out (VdpPort+1),a
        ex de,hl
        do
            push bc
                ld c,CharHeight
                do
                    ld e,(hl) | inc hl
                    ld a,(InitMonoChar_@Param3)
                    ld d,a
                    ld b,4
                    do
                        bit 0,d
                        if nz
                            ld a,e
                        else
                            xor a
                        endif
                        out (VdpPort),a
                        srl d
                    dwnz
                    dec c
                while nz | wend
            pop bc
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void InitColorChar(word vram, ptr<byte> p, byte count);
cseg
InitColorChar_: public InitColorChar_
    push af | push hl | push de | push bc
        ld a,l | out (VdpPort+1),a
        ld a,h | or 40h | out (VdpPort+1),a
        ex de,hl
        do
            ld b,CharHeight*4
            do
                ld a,(hl) | inc hl
                out (VdpPort),a
            dwnz
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret


; void ClearScreen();
cseg
ClearScreen_:
    public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram_PatternName
        ld bc,VramHeight*VramRowSize
        xor a
        call FILVRM

        ld hl,Vram_SpriteAttribute
        ld bc,64
        ld a,0d0h
        call FILVRM
    pop bc | pop hl | pop af
ret


; word Put(word vram, byte c);
cseg
Put_: public Put_
    push af
        di
            ld a,l | out (VdpPort+1),a
            ld a,h | or 40h | out (VdpPort+1),a
            ld a,e
            out (VdpPort),a
            nop | nop | nop
            xor a
            out (VdpPort),a
        ei
    pop af
    inc hl
    inc hl
ret


; word PrintC(word vram, byte c);
cseg
PrintC_: public PrintC_
    push af
        di
            ld a,l | out (VdpPort+1),a
            ld a,h | or 40h | out (VdpPort+1),a
            ld a,e
            sub ' '
            out (VdpPort),a
            nop | nop | nop
            xor a
            out (VdpPort),a
        ei
    pop af
    inc hl
    inc hl
ret


; void VVramToVram();
cseg
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld de,VVram_
        ld hl,VramTop or 4000h
        ld a,VVramHeight
        do
            ex af,af'
                di
                    ld a,l | out (VdpPort+1),a
                    ld a,h | or 40h | out (VdpPort+1),a
                    ld b,VVramWidth
                    do
                        ld c,0
                        ld a,(de)
                        inc de
                        out (VdpPort),a
                        nop | nop | nop
                        xor a
                        out (VdpPort),a
                    dwnz
                ei
            ex af,af'
            ld bc,VramRowSize
            add hl,bc
            dec a
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret
